/* Copyright (c) 2002 Petr Bilek
   Tento kod je volne programove vybaveni; muzete jej sirit a modifikovat
podle ustanoveni Obecne verejne license GNU, vydavane FreeSoftware Foundation.
Na tento program se nevztahuji ZADNE ZARUKY; neposkytuji se ani odvozene zaruky
PRODEJNSTI anebo VHODNOSTI PRO URCITY UCEL. */
/* soubor textnapovedy.c */

#include <unistd.h>
#include <stdlib.h>
#include "struktury.h"
#include "lib.h"
#include "textnapovedy.h"

char *text_n(void)
{
    return text_napovedy;
}

char *text_n2(void)
{
    static char *h;
    FILE *soubor;
    long delkas;
    static boolean nactihlp;    /* napoveda se nacte jen jedenkrat */

    if (!nactihlp) {
        if ((soubor = fopen(jmeno_napovedy(), "rt")) == NULL)
            return text_n();

        (void) fseek(soubor, 0, SEEK_END);
        delkas = ftell(soubor);
        rewind(soubor);

        h = (char *) malloc((size_t) delkas + 1);
        if (h == NULL)
            return text_n();

        if (fread(h, delkas, 1, soubor) == 0)
            return text_n();
        fclose(soubor);
        nactihlp++;
        h[delkas] = '\0';
    }

    return h;
}

type_vety text_n3(void)
{
    FILE *soubor;
    long delkas, i;
    type_vety v;

    v.vety = NULL;
    v.pocet = 0;
    v.oddelovac = '#';

    if ((soubor = fopen(jmeno_napovedy3(), "rt")) == NULL)
        return v;

    (void) fseek(soubor, 0, SEEK_END);
    delkas = ftell(soubor);
    rewind(soubor);

    v.vety = (char *) malloc((size_t) delkas);
    if (v.vety == NULL)
        return v;

    if (fread(v.vety, delkas, 1, soubor) == 0) {
        v.vety = NULL;
        return v;
    }
    fclose(soubor);

    for (i = 0; i < delkas; i++)
        if (v.vety[i] == v.oddelovac)
            v.pocet++;
    return v;
}
